If (-NOT ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole]::Administrator))
{
  # Relaunch as an elevated process:
  Start-Process powershell.exe "-File",('"{0}"' -f $MyInvocation.MyCommand.Path) -Verb RunAs
  exit
}

# This script is an All-In-One Powershell script encapsulating the standard post-installation 
# scripts listed in the installation documenation.

Write-Host "****************************************************"
Write-Host "****************************************************"
Write-Host "         Stopping VIX and Tomcat Services"
Write-Host "****************************************************"
Write-Host "****************************************************"
# Patch 249 Service Stop
#Shut down and restart Tomcat
$tomcatname = "Tomcat8"
$viewername = "VIX Viewer Service"
$rendername = "VIX Render Service"
$listenername = "ListenerTool"

$tomcatpid = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty ProcessId
$tomcatstatus = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty Status
$tomcatstate = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State
echo "***** Tomcat8 Service *****"
echo "Tomcat PID:  $tomcatpid"
echo $tomcatstatus
echo $tomcatstate

if ($tomcatstate -eq 'Running') {
	echo "$tomcatname service is running.  Stopping service..."
	Stop-Service -Name "$tomcatname" -Force
	#verifying service stopped
	Start-Sleep -s 10
	$tomcatstate2 = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$tomcatname'" | Select-Object -ExpandProperty State
	echo "$tomcatname is $tomcatstate2"
	if ($tomcatstate2 -eq 'Stopped') {
		echo "Tomcat service successfully stopped"
	}
} else {
	echo "$tomcatname was not running"	
}

#Shut down and restart VIX Viewer Service
$viewerpid = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$viewername'" | Select-Object -ExpandProperty ProcessId
$viewerstatus = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$viewername'" | Select-Object -ExpandProperty Status
$viewerstate = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$viewername'" | Select-Object -ExpandProperty State
echo "***** VIX Viewer Service *****"
echo "Viewer PID:  $viewerpid"
echo $viewerstatus
echo $viewerstate

if ($viewerstate -eq 'Running') {
	echo "Viewer service is running.  Stopping service..."
	Stop-Service -Name "$viewername" -Force
	#verifying service stopped
	Start-Sleep -s 10
	$viewerstate2 = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$viewername'" | Select-Object -ExpandProperty State
	echo "$viewername is $viewerstate2"
	if ($viewerstate2 -eq 'Stopped') {
		echo "Viewer service successfully stopped.  Checking for orphaned processes..."
		$viewerprocs = (Get-Process | Where-Object {$_.Name -eq 'Hydra.VistA.Worker'}).count
		echo "Viewer process count: $viewerprocs"
		if ($viewerprocs -gt 0) {
			echo "There are existing orphaned processes."
			echo "Killing orphans...so sad."
			Stop-Process -Name "Hydra.VistA.Worker" -Force
		}
	}
} else {
	echo "$viewername was not running."
	echo "Looking for orphan processes..."
	$viewerprocs = (Get-Process | Where-Object {$_.Name -eq 'Hydra.VistA.Worker'}).count
	echo "Viewer process count: $viewerprocs"
	if ($viewerprocs -gt 0) {
		echo "There are existing orphaned processes."
		echo "Killing orphans...so sad."
		Stop-Process -Name "Hydra.VistA.Worker" -Force
	}
}

#Shut down and restart VIX Render Service
$renderpid = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$rendername'" | Select-Object -ExpandProperty ProcessId
$renderstatus = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$rendername'" | Select-Object -ExpandProperty Status
$renderstate = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$rendername'" | Select-Object -ExpandProperty State
echo "***** VIX Render Service *****"
echo "Render PID:  $renderpid"
echo $renderstatus
echo $renderstate

if ($renderstate -eq 'Running') {
	echo "Render service is running.  Stopping service..."
	Stop-Service -Name "$rendername" -Force
	#verifying service stopped
	Start-Sleep -s 10
	$renderstate2 = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$rendername'" | Select-Object -ExpandProperty State
	echo "$rendername is $renderstate2"
	if ($renderstate2 -eq 'Stopped') {
		echo "Render service successfully stopped.  Checking for orphaned processes..."
		$renderprocs = (Get-Process | Where-Object {$_.Name -eq 'Hydra.IX.Processor'}).count
		echo "Render process count: $renderprocs"
		if ($renderprocs -gt 0) {
			echo "There are existing orphaned processes."
			echo "Killing orphans...so sad."
			Stop-Process -Name "Hydra.IX.Processor" -Force
		}
	}
} else {
	echo "$rendername was not running."
	echo "Looking for orphan processes..."
	$renderprocs = (Get-Process | Where-Object {$_.Name -eq 'Hydra.IX.Processor'}).count
	echo "Render process count: $renderprocs"
	if ($renderprocs -gt 0) {
		echo "There are existing orphaned processes."
		echo "Killing orphans...so sad."
		Stop-Process -Name "Hydra.IX.Processor" -Force
	}
}

#Shut down and restart Listener Tool Service
$listenerpid = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$listenername'" | Select-Object -ExpandProperty ProcessId
$listenerstatus = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$listenername'" | Select-Object -ExpandProperty Status
$listenerstate = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$listenername'" | Select-Object -ExpandProperty State
echo "***** ListenerTool Service *****"
echo "Listener PID:  $listenerpid"
echo $listenerstatus
echo $listenerstate

if ($listenerstate -eq 'Running') {
	echo "Listener service is running.  Stopping service..."
	Stop-Service -Name "$listenername" -Force
	#verifying service stopped
	Start-Sleep -s 10
	$listenerstate2 = Get-WmiObject -Class Win32_Service -Filter "Name LIKE '$listenername'" | Select-Object -ExpandProperty State
	echo "$listenername is $listenerstate2"
	if ($listenerstate2 -eq 'Stopped') {
		echo "Listener service successfully stopped."
	}
} else {
	echo "$listenername was not running."
}

Write-Host "End of Service Shutdown Section"


Write-Host "****************************************************"
Write-Host "****************************************************"
Write-Host "               VIX Config Editor"
Write-Host "****************************************************"
Write-Host "****************************************************"
# Patch 249 VIX Config Editor

# File location for pre-install backups
$preRenderFile = "C:\VixConfig\PreInstall\P249\VIX.Render.config"
$preViewerFile = "C:\VixConfig\PreInstall\P249\VIX.Viewer.config"
$preServerFile = "C:\VixConfig\PreInstall\P249\server.xml"
$preMuseFile = "C:\VixConfig\PreInstall\P249\MuseDataSource-1.0.Config"
$preCacheFile = "C:\VixConfig\PreInstall\P249\ImagingExchangeCache-cache.xml"

# File location for critical files
$renderFile = "C:\Program Files\VistA\Imaging\VIX.Config\VIX.Render.config"
$viewerFile = "C:\Program Files\VistA\Imaging\VIX.Config\VIX.Viewer.config"
$serverFile = "C:\Program Files\Apache Software Foundation\Tomcat 8.0\conf\server.xml"
$museFile = "C:\VixConfig\MuseDataSource-1.0.Config"
$cacheFile = "C:\VixConfig\cache-config\ImagingExchangeCache-cache.xml"

$patchString = "<!-- Changed in MAG*3.0*249 - $($myDate) -->"

Write-Host "getting computer name..."
$myname = (Get-WmiObject win32_computersystem).DNSHostName+"."+(Get-WmiObject win32_computersystem).Domain
Write-Host "computer name: $myname"

$myTimestamp = Get-Date -Format 'yyyyMMdd.HHmmss'
Write-Host $myTimestamp

$backupFiles = @($renderFile, $viewerFile, $serverFile, $museFile, $cacheFile)

foreach ($backup in $backupFiles)
{
    Write-Host "Backing up $($backup) ..."

    $destFile = "$($backup)_$($myTimestamp)"

    Copy-Item "$($backup)" "$($destFile)"
    if (Test-Path "$($destFile)") {
	    Write-Host "backup successful"
    } else {
	    Write-Host "backup failed!!!!"
    }
}

Write-Host "***** Editing VIX.Render.config File *****"
Write-Host "copying pre-install backup..."
Copy-Item "$($preRenderFile)" "$($renderFile)"
Write-Host "setting string variables..."
$varTiffOld = "ConvertTiffToPdf"
$varTiffNew = "    <Processor WorkerPoolSize=`"10`" UseSeparateProcess=`"true`" ReprocessFailedImages=`"false`" ConvertTiffToPdf=`"true`" MaxPagesTiffToPdf=`"75`" OpTimeOutMins=`"5`">"
$varTiffNewTotal = "    $($patchString)`n$($varTiffNew)"
Write-Host $varTiffOld
Write-Host $varTiffNew

Write-Host "Checking to see if file actually needs to be edited"
if (Get-Content $($renderFile) | Where-Object {$_ -like "*$($varTiffNew)*"}) {
	Write-Host "P249 TIFF edit found, edit aborted."
} else {
	Write-Host "P249 TIFF edit not found.  Proceeding with VIX.Render.config edit."

    Write-Host "search and replace..."
    $tiffLine = Get-Content $($renderFile) | Select-String $($varTiffOld) | Select-Object -ExpandProperty Line
    $tiffLineNumber = Get-Content $($renderFile) | Select-String $($varTiffOld) | Select-Object -ExpandProperty LineNumber
    $myline = $($tiffLine)
    $mylinenumber = $($tiffLineNumber) - 1
    Write-Host "This is the line to be replaced:  $($myline)"
    Write-Host "This is the line number to be replaced:  $($mylinenumber)"

    $newServiceLine = Get-Content $($renderFile)
    $newServiceLine[$($mylinenumber)] = $($varTiffNewTotal)
    $newServiceLine | Set-Content $($renderFile)

    Write-Host "validating edit was successful..."
    if (Get-Content $($renderFile) | Where-Object {$_ -like "*$($varTiffNew)*"}) {
	    Write-Host "New TIFF Edit Found"
    } else {
	    Write-Host "New TIFF Edit Not Found!!!!"
    }
}

Write-Host "***** Editing VIX.Viewer.config File *****"
Write-Host "copying pre-install backup..."
Copy-Item "$($preViewerFile)" "$($viewerFile)"
Write-Host "setting string variables..."
$varServiceOld = "VixService ServiceType=`"Viewer`""
$varServiceNew = "      <VixService ServiceType=`"Viewer`" RootUrl=`"https://+:343`" PublicHostName=`"$($myname)`" TrustedClientRootUrl=`"https://+:344`" />"
$varServiceNewTotal = "      $($patchString)`n$($varServiceNew)"
Write-Host $varServiceOld
Write-Host $varServiceNew

Write-Host "Checking to see if file actually needs to be edited"
if (Get-Content $($viewerFile) | Where-Object {$_ -like "*$($varServiceNew)*"}) {
	Write-Host "P249 HTTPS edit found, edit aborted."
} else {
	Write-Host "P249 HTTPS edit not found.  Proceeding with VIX.Viewer.config edit."

    Write-Host "search and replace..."
    $serviceLine = Get-Content $($viewerFile) | Select-String $($varServiceOld) | Select-Object -ExpandProperty Line
    $serviceLineNumber = Get-Content $($viewerFile) | Select-String $($varServiceOld) | Select-Object -ExpandProperty LineNumber
    $myline = $($serviceLine)
    $mylinenumber = $($serviceLineNumber) - 1
    Write-Host "This is the line to be replaced:  $($myline)"
    Write-Host "This is the line number to be replaced:  $($mylinenumber)"

    $newServiceLine = Get-Content $($viewerFile)
    $newServiceLine[$($mylinenumber)] = $($varServiceNewTotal)
    $newServiceLine | Set-Content $($viewerFile)

    Write-Host "validating edit was successful..."
    if (Get-Content $($viewerFile) | Where-Object {$_ -like "*$($varServiceNew)*"}) {
	    Write-Host "New HTTPS Edit Found"
    } else {
	    Write-Host "New HTTPS Edit Not Found!!!!"
    }
}


Write-Host "***** Restoring Pre-Install Tomcat Server File *****"
Write-Host "copying pre-install backup..."
Copy-Item "$($preServerFile)" "$($serverFile)"


Write-Host "***** Restoring Pre-Install Cache Config File *****"
Write-Host "copying pre-install backup..."
Copy-Item "$($preCacheFile)" "$($cacheFile)"


Write-Host "***** Restoring Pre-Install Muse Config File *****"
Write-Host "creating MuseDataSource config template..."
# Assign the XML Output File Paths
$XML_Path = "C:\VixConfig\MuseDataSource-1.0.Config"
# Create the XML File Tags
$xmlWriter = New-Object System.XMl.XmlTextWriter($XML_Path,$Null)
$xmlWriter.Formatting = 'Indented'
$xmlWriter.Indentation = 1
$XmlWriter.IndentChar = "`t"
$xmlWriter.WriteStartDocument()
$xmlWriter.WriteComment('MAG*3.0*249 MUSE Configuration File')
$xmlWriter.WriteStartElement('gov.va.med.imaging.musedatasource.configuration.MuseConfiguration')  
# Create the Initial  Node
$xmlWriter.WriteStartElement("servers")
$xmlWriter.WriteStartElement("gov.va.med.imaging.musedatasource.configuration.MuseConfiguration")
$xmlWriter.WriteElementString("id", "0")
$xmlWriter.WriteElementString("museSiteNumber", "***MUSE SITE NUMBER HERE***")
$xmlWriter.WriteElementString("host", "***MUSE HOST HERE***")
$xmlWriter.WriteElementString("port", "***MUSE PORT HERE***")
$xmlWriter.WriteElementString("metadataTimeoutMs", "60000")
$xmlWriter.WriteElementString("username", "***MUSE USER HERE***")
$xmlWriter.WriteElementString("password", "***MUSE PWD HERE***")
$xmlWriter.WriteElementString("protocol", "http")
$xmlWriter.WriteElementString("museDisabled", "false")
$xmlWriter.WriteEndElement()
$xmlWriter.WriteEndElement()
$xmlWriter.WriteElementString("museAPIKey", "1SN5TirlkdA4OEAU6A9o8_ecZFga4AsMNjo7Lc4JcJCTVgKCncSWlVZPsA-nyxL3ZQ-J1ZF04hMr-24Rv9Q01w2")
$xmlWriter.WriteElementString("museApplicationName", "MUSEAPIREST")
$xmlWriter.WriteEndDocument()
$xmlWriter.Flush()
$xmlWriter.Close()


Write-Host "****************************************************"
Write-Host "****************************************************"
Write-Host "           SSL Cert and Port Binding"
Write-Host "****************************************************"
Write-Host "****************************************************"
# Patch 249 SSL Cert Binding

Write-Host "getting computer name..."
$myname = (Get-WmiObject win32_computersystem).DNSHostName+"."+(Get-WmiObject win32_computersystem).Domain
Write-Host "computer name: $myname"

$mythumbarray = Get-Item cert:\LocalMachine\My\* | Where-Object {$_.Subject -like "*$myname*"} | Select-Object -ExpandProperty Thumbprint

foreach ($mythumb in $mythumbarray)
{
	Write-Host $mythumb
	
	$myuse = Get-Item cert:\LocalMachine\My\$mythumb | Select-Object -ExpandProperty EnhancedKeyUsageList
	Write-Host $myuse
	
	if ("$myuse" -like "*Client Authentication*")
	{
		$myExpiration = Get-Item cert:\LocalMachine\My\$mythumb | Select-Object -ExpandProperty NotAfter
		Write-Host "Cert expires in:  $($myExpiration)"	
		
		$varThumbprint = $mythumb
		Write-Host "***** $varThumbprint matches! *****"
		Write-Host "showing ssl bindings..."
		"netsh http show sslcert" | cmd
		Write-Host "binding current SSL thumbprint to port 343..."
		"netsh http add sslcert ipport=0.0.0.0:343 appid={00000000-0000-0000-0000-000000000000} certhash=`"$varThumbprint`"" | cmd
		Write-Host "binding current SSL thumbprint to port 344..."
		"netsh http add sslcert ipport=0.0.0.0:344 appid={00000000-0000-0000-0000-000000000000} certhash=`"$varThumbprint`"" | cmd
		Write-Host "showing ssl bindings..."
		"netsh http show sslcert" | cmd
		
		Write-Warning "If these steps fail, it's usually because there is already"
		Write-Warning "an SSL cert bound to these specific ports.  Please confirm"
		Write-Warning "or email VAITVistAImagingTech@domain with this error message."
	} else {
		Write-Host "This is not the cert we're looking for.  Next."
	}
}

Write-Host "End of SSL section"

Write-Host "****************************************************"
Write-Host "****************************************************"
Write-Host "          Service Restart Task Scheduler"
Write-Host "****************************************************"
Write-Host "****************************************************"
# Patch 249 Scheduled Task Installer

Write-Host "This creates a scheduled task to restart Tomcat and VIX services."
Write-Host "It defaults to run at 4:00AM.  Site admins can change this if desired."

$myVar = Get-ScheduledTask -TaskName "Imaging Services Daily Restart"

if ($myVar) {
	Write-Host "Scheduled Task already exists."
} else { 
	Write-Host "Scheduled Task Not Found"
	Write-Host "Installing Scheduled Task..."
	
	$Action = New-ScheduledTaskAction -Execute "PowerShell.exe" -Argument  "-file `"C:\Program Files\VistA\Imaging\Scripts\p249_vix_services.ps1`""
	$Trigger = New-ScheduledTaskTrigger -Daily -At 4:00am
	$User = "NT AUTHORITY\SYSTEM"
	Register-ScheduledTask -Action $Action -Trigger $Trigger -User $User -TaskName "Imaging Services Daily Restart" -Description "MAG*3.0*249" -RunLevel "Highest"
}


Write-Warning "Please make sure to complete the MUSE configuration edits to"
Write-Warning "C:\VixConfig\MuseDataSource-1.0.Config"

Pause




