Write-Host "This creates a scheduled task to restart Tomcat and VIX services."
Write-Host "It defaults to run at 4:00AM.  Site admins can change this if desired."

$myVar = Get-ScheduledTask -TaskName "Imaging Services Daily Restart"

if ($myVar) {
	Write-Host "Scheduled Task already exists."
} else { 
	Write-Host "Scheduled Task Not Found"
	Write-Host "Installing Scheduled Task..."
	
	$Action = New-ScheduledTaskAction -Execute "PowerShell.exe" -Argument  "-file `"C:\Program Files\VistA\Imaging\Scripts\p249_vix_services.ps1`""
	$Trigger = New-ScheduledTaskTrigger -Daily -At 4:00am
	$User = "NT AUTHORITY\SYSTEM"
	Register-ScheduledTask -Action $Action -Trigger $Trigger -User $User -TaskName "Imaging Services Daily Restart" -Description "MAG*3.0*249" -RunLevel "Highest"
}

echo "DONE"