Write-Host "begin"

#$mythumbs = Get-Item cert:\LocalMachine\My\* | Where-Object {$_.Subject -like "*VHAIS*"} | Format-List Thumbprint, EnhancedKeyUsageList
Write-Host "getting computer name..."
$myname = (Get-WmiObject win32_computersystem).DNSHostName+"."+(Get-WmiObject win32_computersystem).Domain
Write-Host "computer name: $myname"

$mythumbarray = Get-Item cert:\LocalMachine\My\* | Where-Object {$_.Subject -like "*$myname*"} | Select-Object -ExpandProperty Thumbprint

foreach ($mythumb in $mythumbarray)
{
	Write-Host $mythumb
	
	$myuse = Get-Item cert:\LocalMachine\My\$mythumb | Select-Object -ExpandProperty EnhancedKeyUsageList
	Write-Host $myuse
	
	if ("$myuse" -like "*Client Authentication*")
	{
		$myExpiration = Get-Item cert:\LocalMachine\My\$mythumb | Select-Object -ExpandProperty NotAfter
		Write-Host "Cert expires in:  $($myExpiration)"	
		
		$varThumbprint = $mythumb
		Write-Host "***** $varThumbprint matches! *****"
		Write-Host "showing ssl bindings..."
		"netsh http show sslcert" | cmd
		Write-Host "binding current SSL thumbprint to port 343..."
		"netsh http add sslcert ipport=0.0.0.0:343 appid={00000000-0000-0000-0000-000000000000} certhash=`"$varThumbprint`"" | cmd
		Write-Host "binding current SSL thumbprint to port 344..."
		"netsh http add sslcert ipport=0.0.0.0:344 appid={00000000-0000-0000-0000-000000000000} certhash=`"$varThumbprint`"" | cmd
		Write-Host "showing ssl bindings..."
		"netsh http show sslcert" | cmd
	} else {
		Write-Host "No standard use certificate found where expected."
		Write-Host "Please send an email to VAITVistAImagingTech@domain with this error message."
	}
}

<#
Write-Host "********************"
Write-Host "deleting binding..."
"netsh http delete sslcert ipport=0.0.0.0:343" | cmd
Write-Host "deleted"
"netsh http show sslcert" | cmd
Write-Host "success"
#>


Write-Host "done"